/*******************************************************************************
*
*   print a window giving the winner !
*
*******************************************************************************/

#include <stdio.h>
#include <qdos.h>
/* #include <ios1.h> */
#include <qptr.h>
#include <stdarg.h>
#include "jeu.h"
extern struct WM_SPRITE sp4_rose;

static long ACHOICE();
static struct WM_action achoice = {JSR, wm_actli, ACHOICE};

int window_about()
{  
   char *itxt;
   int icount;
   short pulld_wid, pr_wid, lit_wid;

#define pr_max 120
   static QD_TEXT(pr_max) _prompt;
#define litm_max 20
#define nlitm_max 6
   static QD_TEXT(litm_max) _litm;
   static QD_TEXTI(freesoft,"Free QL soft by");
   static QD_TEXTI(nom,     "Jrme GRIMBERT");
   static QD_TEXTI(compi,   "-- No Charge --");
#define pulld_min 100
#define pulld_hgt 113
#define bord_x 2

   struct WM_wstat ws; /* this time ws is initialised in code */

   static struct WM_info info[4+1] =   /* information objects */
   {
    {96,60,                  /* xsize, ysize         size */
     (pulld_min-96)/2,2,                    /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},                     /* spare for sprite */
     &sp4_rose           /* *pobj                pointer to object */
    }
    ,{pulld_min-10,11,      /* xsize, ysize         size */
     4,65,                  /* xorg, yorg           and origin */
     TYP_TEXT,0,          /* type, skey           type and select key */
     {0,0,0},
     &freesoft             /* *pobj                pointer to object */
   }
    ,{pulld_min-10,11,      /* xsize, ysize         size */
     4,77,                  /* xorg, yorg           and origin */
     TYP_TEXT,0,          /* type, skey           type and select key */
     {0,0,0},
     &nom                 /* *pobj                pointer to object */
   }
    ,{pulld_min-10,11,      /* xsize, ysize         size */
     4,88,                  /* xorg, yorg           and origin */
     TYP_TEXT,0,          /* type, skey           type and select key */
     {2,0,0},
     &compi                 /* *pobj                pointer to object */
   }
    ,{-1}                    /* end of array */
   };

   static struct WM_infw infw[1+1] =  /* information window */
   {
    {pulld_min-2,100,          /* xsize, ysize         size */
     2,1,              /* xorg, yorg           and origin */
     NO_WCLEAR,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

   ,{-1}                    /* end of array */
   };

   static struct WM_litm litm[1+1] =   /* loose item */
   {
    {(pulld_min-8),10,      /* xsize, ysize         size */
     4,pulld_hgt-13,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,K_CANCEL,          /* type, skey           type and select key */
     &_litm,                 /* *pobj                pointer to object */
     1,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

   ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     pulld_min+bord_x*2,pulld_hgt,  /* xsize, ysize */
     pulld_min/2,40,                           /* xorg, yorg           and origin */
     4,                     /* flag                 no clear + shadow */
     2,CL_MBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,CL_MHIGH,            /* curw, curc           current item width/clr */

     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     CL_MPAVBL,CL_MIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     CL_MPSLCT,CL_MISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     2,1,infw,              /* ninfo, ninob, *pinfo info winds */
     6,litm,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };


   ws.wwork=&ww;  /* cross references */
   ww.wstat=&ws;


   {
      char s[litm_max];
      sprintf(s,"%s",__DATE__);
      
      QD_STXT (_litm, s, litm_max);          /* loose item string */
      
   }
   ws.citem = -1;                   /* no current item  */
   ws.ciact = NULL;                 /* or current item routine */
   {int i;for(i=0;i<nlitm_max;ws.litem[i++]=0);}
   ws.litem[nlitm_max] = -1;        /* preset ESC return */
   ww.xorg=pulld_min/2;             /* we have STATIC struct */
   ww.yorg=pulld_hgt-10;            /* corrupted when use */

   wm_pulld (&ww,-1,-1);               /* pull down */
   wm_wdraw (&ww);

   while (!wm_rptr(&ww)) {if (ws.evnt & PT_CAN) break;}

   wm_cluns (&ww);                   /* throw it away */

   return 0;      /* return code number */
}

static long ACHOICE (wwk,li,wst) struct WM_wwork *wwk; struct WM_litm *li; struct WM_wstat *wst;
{
   wst->litem[nlitm_max]=li->item;  /* set item hit in status area */
   return PT__CAN;                  /* and return CAN event */
}
