#ifndef _WIND_EG_H
#define _WIND_EG_H
/**
*
* This header file defines various bits for the Window Manager Examples.
*
**/


#ifndef _STDIO_H
#include <stdio.h>
#endif

#include <qdos.h>
#include <qptr.h>


#define lit_move 0            /* standardised item numbers */
#define lit_size 1            /* used in example wind_4 onwards */
#define lit_can  2
#define lit_wake 3
#define lit_zzzz 4            /* used in menu_choice_h (ex wind_7 onwards) */
#define lit_do   5
#define lit_about 6
#define lit_play              14
#define lit_help    7
#define k_delete 0xc2         /* QL delete key */

#define K_PLAY                'P'
#define K_ABOUT               '?'

#define X_MAX_CARRE 19
#define Y_MAX_CARRE 19
#define INITIAL 1000
struct astat     /* dummy application sub-window structure */
{
  int redraw;                /* used in examples wind_5, 5a */
  chanid_t chid;                 /* used in examples wind_5c ff */
  long grille[421];
  long t; /* nombre de coup */
  long p[2]; /* nombre de prise */
  char jo; /* joueur */
  char nb; /* number of player */
  struct WM_info *red,*green;
};

struct list      /* list structures for menus */
{
   struct list *next; /* linked list pointer */
};

struct str_list
{
   struct str_list *next;   /* linked list pointer */
#define str_list_str     sizeof(struct str_list *)
   short slen;              /* length of string */
#define str_list_chrs    (sizeof(short) + str_list_str)
   qchar_t chrs[1];         /* characters of string */
};


#endif
