/* This program is free : no charge, even for copying or anything else */
/* Any alteration is at your own risk */
/* Any use too! */

#include <stdio.h>
#include <qdos.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "gnugo.h"
#include <qptr.h>
#include "jeu.h"
#include <xmenu.h>

char CHARAC_SIZE=6;
extern struct WM_sprite mes_size,sp4_drouge,sp4_dvert,sp4_dnoir;
extern struct WM_sprite mes_rouge,sp4_rose;
extern struct WM_sprite mes_vert,;
extern struct WM_sprite sp4_basdroite,sp4_droite,sp4_gauche,sp4_basgauche;
extern struct WM_sprite sp4_hautdroite,sp4_haut,sp4_bas,sp4_hautgauche;
extern struct WM_sprite sp4_milieu,sp4_noeud,sp4_rouge,sp4_vert,sp4_fem,sp4_help;
extern struct WM_sprite sp_remove1;
struct WINDOWDEF _condetails = 
                    { (char) 0,(char) 0,(char)0,(char)4 ,
                      (short)2,(short)1,(short)0,(short)0};


char _conname[] = "con_2x1a0x0";      /* mask startup problems, for old one */
char *_endmsg  = NULL;                /* and stop when I say */

char _PROG_NAME[] = "GO";
QD_TEXTI( red_score,"You.");
QD_TEXTI( green_score,"-QL-");
static QD_TEXTI (coup,"None");

#define BSIZE 19
#define NODES BSIZE*BSIZE
#define ENDLIST 1000
#define QSIZE 150
#define GREY  3


int mymovelist[NODES][5];
int umovelist[NODES][5];
extern int listpt[BSIZE*BSIZE];



unsigned char p[19][19];  /* go board */
unsigned char t[19][19];  /* go board for endboard */
unsigned char l[19][19];  /* liberty of current color */
unsigned char ma[19][19]; /* working matrix for marking */
unsigned char ml[19][19]; /* working matrix for marking */
int mymove, umove;        /* computer color, opponent color */
int lib;                  /* current stone liberty */
int play;                 /* game state */
int pass;                 /* pass indicator */
int mik, mjk;             /* location of computer stone captured */
int uik, ujk;             /* location of opponent stone captured */
int mk, uk;               /* no. of stones captured by computer and oppoent */
int opn[9];               /* opening pattern flag */



long lit_event();
/* long treat_select(); */
static long AEXIT(), AMOVE(), AWAKE(), ADRAW(), AHIT(), ASLEEP(),APASS(),AHELP(),ABOUT();
struct WM_action afun  = {JSR, wm_actli, lit_event};
struct WM_action aexit = {JSR, wm_actli, AEXIT};
struct WM_action ahelp = {JSR, wm_actli, AHELP};
struct WM_action aabout = {JSR, wm_actli, ABOUT};
struct WM_action amove = {JSR, wm_actli, AMOVE};
struct WM_action asleep = {JSR, wm_actli, ASLEEP};
struct WM_action awake = {JSR, wm_actli, AWAKE};
struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
struct WM_action ahit  = {JSR, wm_hitaw, AHIT};
struct WM_action apass = {JSR, wm_actli, APASS};
/* struct WM_action asel  = {JSR, wm_actli, treat_select}; */

main()
{
   static struct WM_wstat ws =  /* window status area */
   {
     NULL,                  /* *wwork               point back to work def */
     NULL,                  /* *wdef                this was wdef */
     0,                     /* chid                 chan ID enclosing pointer */
     0,0,0,                 /* swnr, xpos, ypos     sub-window and ptr posn */
     0,0,                   /* kstk, kprs           key stroke and press */
     0,                     /* evnt                 event vector */
     0,0,0,0,               /* xsiz, ysiz, xorg, yorg  */
     0,0,                   /* ptpsx, ptpsy         pointer position (abs) */
     FORM_QL4,0,0,                 /* wmode, 2 spare       window mode and spare */

     NULL,                  /* *ciact               current item "action" */
     -1,                    /* citem                current item */
     0,0,0,                 /* cibrw, cipap, cispr  current item attr */
     0,0,0,0,               /* cihxs,ys, cihxo,yo   current item hit area */

     {0,0,0,0,0,0,0,0}      /* litem[40]            loose item status */
   };

   static struct astat ast = {0};  /* workspace for application sub window */

#define wind_wid  380    /* application sw size */
#define wind_hgt  247
#define xt_wid     8     /* extra width of window */
#define xt_hgt    0
#define tot_wid  480+xt_wid
#define tot_hgt  249+xt_hgt

#define min_wid  480+xt_wid     /* and limits */
#define min_hgt  249+xt_hgt      /* due to window_resultat... */
#define max_wid  496+xt_wid
#define max_hgt  249+xt_hgt

#define lit_top  100      /* allowance for loose items in top row */
#define ninfw    6       /* number of information windows */
#define ninfo    5       /* number of information objects */
#define nlitm    7       /* number of loose items */
#define nappl    1       /* number of application sub-windows */

#define tit_text "Go"
#define tit_wid ((sizeof(tit_text)-1)*6)
#define tit_two_players   "Deux joueurs"
#define tit_one_player    "Un Joueur"
#define tit_compute       "L'ordinateur"
#define tit_about         "About"

#define gen_wid(a) ((sizeof((a))-1)*6)
   static QD_TEXTI (title,tit_text);

   static QD_TEXTI (ESC,"ESC");
   static QD_TEXTI (compute,tit_compute);
   static QD_TEXTI (two_players,tit_two_players);
   static QD_TEXTI (one_player,tit_one_player);
   static QD_TEXTI (about,tit_about);
   static QD_TEXTI (tpass,"Pass");

   static struct WM_info info[1+1] =   /* information objects */
   {
    {tit_wid,10,            /* xsize, ysize         size */
     2,1,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     &title}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info infored[1+1] =   /* information objects */
   {
    {60,20,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {2,2,1},         /* ink, cwid, chgt      character attributes */
     &red_score}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info infogreen[1+1] =   /* information objects */
   {
    {60,20,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {4,2,1},         /* ink, cwid, chgt      character attributes */
     &green_score}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info infologo[1+1] =   /* information objects */
   {
    {68,60,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &xmenu_logo}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info infocoup[1+1] =   /* information objects */
   {
    {60,20,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {0,2,1},         /* ink, cwid, chgt      character attributes */
     &coup}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_infw infw[ninfw+1] =  /* information window */
   {
    {tot_wid-wind_wid-4,14, /* xsize, ysize       size */
     wind_wid+4,1,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     0,0,CL_MFILL,          /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */

   ,{tit_wid+6,11,          /* xsize, ysize         size */
     wind_wid+((tot_wid)-(wind_wid)-(tit_wid)-8)/2,2,  /* xorg, yorg     and origin */
     0,                     /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */


   ,{64,24, /* xsize, ysize       size */
     (wind_wid+tot_wid)/2-32,82,         /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     2,0177,7,          /* borw, borc, papr     border width/clr, paper */
     infored}                  /* *pobj                pointer to object list */
 ,
    {64,24, /* xsize, ysize       size */
     (tot_wid+wind_wid)/2-32,142,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     2,0277,7,          /* borw, borc, papr     border width/clr, paper */
     infogreen}                  /* *pobj                pointer to object list */
,
    {64,24, /* xsize, ysize       size */
     (tot_wid+wind_wid)/2-32,112,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     2,0,7,          /* borw, borc, papr     border width/clr, paper */
     infocoup}                  /* *pobj                pointer to object list */
,
    {68,60, /* xsize, ysize       size */
     (tot_wid+wind_wid)/2-34,182,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     0,0,7,          /* borw, borc, papr     border width/clr, paper */
     infologo}                  /* *pobj                pointer to object list */

   ,{-1}                    /* end of array */
   };

   static struct WM_litm litm[nlitm+1] =   /* loose item */
   {
    {24,10,                 /* xsize, ysize         size */
     wind_wid+6,22,          /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_MOVE,     /* type, skey           type and select key */
     &mes_move,             /* *pobj                pointer to object */
     lit_move,              /* item                 item number */
     &amove}                /* *pact                pointer to action */
  
   ,{24,10,                 /* xsize, ysize         size */
     wind_wid+24+8,22,  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_SLEEP,    /* type, skey           type and select key */
     &wm_sprite_sleep,      /* *pobj                pointer to object */
     lit_zzzz,              /* item                 item number */
     &asleep}                 /* *pact                pointer to action */


   ,{24,10,                 /* xsize, ysize         size */
     wind_wid+12+2*24,22,                /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_SIZE,     /* type, skey           type and select key */
     &mes_size,             /* *pobj                pointer to object */
     lit_size,              /* item                 item number */
     &afun}                 /* *pact                pointer to action */

   ,{24,10,                 /* xsize, ysize         size */
     wind_wid+8+24,36,     /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,K_CANCEL,     /* type, skey           type and select key */
     &ESC,                  /* *pobj                pointer to object */
     lit_can,               /* item                 item number */
     &aexit}                /* *pact                pointer to action */

   ,{24,10,                 /* xsize, ysize         size */
     wind_wid+6,36,     /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_WAKE,     /* type, skey           type and select key */
     &mes_wake,             /* *pobj                pointer to object */
     lit_wake,              /* item                 item number */
     &awake}                /* *pact                pointer to action */

   ,{40,12,                 /* xsize, ysize         size */
     wind_wid+6,50,     /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,K_PLAY,     /* type, skey           type and select key */
     &tpass,             /* *pobj                pointer to object */
     lit_play,              /* item                 item number */
     &apass}                /* *pact                pointer to action */
   ,{40,12,                 /* xsize, ysize         size */
     wind_wid+6,66,     /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,'A',     /* type, skey           type and select key */
     &about,             /* *pobj                pointer to object */
     lit_about,              /* item                 item number */
     &aabout}                /* *pact                pointer to action */
   
   ,{-1}                    /* end of array */
   };

   static struct WM_appw aw = /* application sub-window */
   {
     wind_wid,wind_hgt,  /* xsize, ysize         size */
     2,1,              /* xorg, yorg           and origin */
     NO_WCLEAR,             /* flag                 no clear + shadow */
     1,0377,CL_WBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,       /* *pspr                pointer to sprite */

     &adraw,                /* *draw                draw routine */
     &ahit,                 /* *hit                 hit routine */
     NULL,                  /* *ctrl                control routine */
     0,0,                   /* nxsc, nysc           max x,y sections */
     K_TAB,0,0,             /* skey, 2 spare        selection keystroke */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     &ast                   /* *pstat               wind status area (C68) */
   };

   static struct WM_appl appl[nappl+1] = {&aw, NULL};

   static WM_WSCALE(ninfw+ninfo+nlitm+nappl) wsc =
                               {min_wid,min_hgt,max_wid,max_hgt,2,1,
                                {{8,0,0,0},     /* infw[0] scale width */
                                 {0,0,4,0},     /* infw[1] right justified */
                                 {0,0,0,0},       /* info[0] unscaled */
                                 {0,0,4,0},     /* infw[4]  */
                                 {0,0,0,0},       /* info[0] unscaled */
                                 {0,0,4,0},     /* infw[5]  */
                                 {0,0,0,0},       /* info[0] unscaled */
                                 {0,0,4,0},     /* infw[5]  */
                                 {0,0,0,0},       /* info[0] unscaled */
                                 {0,0,8,0},     /* infw[5]  */
                                 {0,0,0,0},       /* info[0] unscaled */
                                 {0,0,0,0},     /* litm[] move : unscaled */
                                 {0,0,0,0},     /* litm[] sleep : unscaled */
                                 {0,0,8,0},     /* litm[] resize : unscaled */
                                 {0,0,0,0},     /* litm[] esc : unscaled */
                                 {0,0,0,0},     /* litm[] esc : unscaled */
                                 {0,0,0,0},     /* litm[] wake : unscaled */
                                 {0,0,0,0},     /* litm[] wake : unscaled */
                                 {0,0,0,0}}};   /* appw[0] fully scaled */

   static struct WM_wwork ww = /* window working definition */
   {
     &ws,                   /* *wstat;              pointer to status area */
     &wsc,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     appl,                  /* *splst               pointer to sprite list */

     tot_wid,tot_hgt,       /* xsize, ysize         size */
     tot_wid/2,tot_hgt/2,   /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,CL_MBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,CL_MHIGH,            /* curw, curc           current item width/clr */

     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     CL_MPAVBL,CL_MIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     CL_MPSLCT,CL_MISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     ninfw,ninfo,infw,      /* ninfo, ninob, *pinfo info winds */
     nlitm,litm,            /* nlitm, *plitm        loose items */
     nappl,appl             /* nappl  *pappl        appl winds */
   };
   FILE *fp;
   int i, j;
   char move[10], ans;
   int cont = 0;
   time_t tm;
   short mode,type;
   mode =-1;
   type=-1;
   mt_dmode(&mode,&type);
   if (mode!=4) { mode=4; mt_dmode(&mode,&type);}
   /* fudge_sprite */
   ww.chid=fgetchid(stdout);
   if (!((long) wm_findv(ww.chid))) exit (-1);

   if ((ast.chid=fgetchid(fopen("scr","w"))) == -1.L) exit (-1); /* spare scr */

   ws.wwork = &ww;        /* set cross reference */
   ast.red=infored;
   ast.green=infogreen;

/* show instruction */
   showinst();

   if ((fp = fopen("gnugo.dat", "r")) != NULL)  /* continue old game */
     {
      cont = 1;

/* read board configuration */
      for (i = 0; i < 19; i++)
        for (j = 0; j < 19; j++)
          fscanf(fp, "%c", &p[i][j]);

/* read my color, pieces captured */
      fscanf(fp, "%d %d %d ", &mymove, &mk, &uk);
/* read opening pattern flags */
      for (i = 0; i < 9; i++)
        fscanf(fp, "%d ", &opn[i]);

      fclose(fp);
      umove = 3 - mymove;

/* delete file */
      remove("gnugo.dat");
    }
   else
     {
/* init opening pattern numbers to search */
      for (i = 0; i < 9; i++)
        opn[i] = 1;
      opn[4] = 0;

/* init board */
      for (i = 0; i < 19; i++)
        for (j = 0; j < 19; j++)
          p[i][j] = EMPTY;
/* init global variables */
      mk = 0;  uk = 0;
    }

   SetWindowColour(&ww,DefaultColourSet());

   wm_prpos (&ww,-1,-1);
   wm_wdraw (&ww);

/* init global variables */
   play = 1;
   pass = 0;
   mik = -1; mjk = -1;
   uik = -1; ujk = -1;
   srand((unsigned)time(&tm));  /* start random number seed */
   if (!cont)  /* new game */
     {
/* ask for handicap */
      i=Radio_Select(DefaultColourSet(),5,"Handicap","Number of handicap for black ?",19,"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18");
      if (i<0) i=0;
      sethand(i);

/* choose color */
      ans=Radio_Select(DefaultColourSet(),0,"Colour","Choose side:",2,"Black","White");

      if (ans != 1) /* not white */
        {
         mymove = 1;   /* computer white */
         umove = 2;   /* human black */
         if (i)
       {
            genmove(&i, &j);   /* computer move */
            p[i][j] = mymove;
          }
       }
      else
        {
         mymove = 2;   /* computer black */
         umove = 1;   /* human white */
         if (i == 0)
       {
            genmove(&i, &j);   /* computer move */
            p[i][j] = mymove;
          }
       }
    }

aw.pspr=(struct WM_sprite *)umove==1?&sp4_vert:&sp4_rouge;
   wm_wdraw (&ww);
   
   while ((!wm_rptr(&ww))&&(play))
{ if (ws.evnt & PT_WSIZE) re_size (&ww,lit_size);
  if (ws.evnt & PT_ZZZZ) Menu_Button_Text(DefaultColourSet(),&ww,_PROG_NAME);
}
   Message_Report(DefaultColourSet(),"End of Play\n\nHit on stone to remove it\nHit on empty slot to add one stone\n\nDo on connected stone to remove them" );
ws.litem[lit_play]=WSI_MKUN;
aw.pspr=&wm_sprite_arrow;
wm_ldraw(&ww,0);


/* Create an adjacency list for the game board. */
/* First a list for the computer's moves */
  createlist(mymove, mymovelist);

/* Then a list for our opponent's moves */
  createlist(umove, umovelist);

while (!wm_rptr(&ww))
{ if (ws.evnt & PT_WSIZE) re_size (&ww,lit_size);
  if (ws.evnt & PT_ZZZZ) Menu_Button_Text(DefaultColourSet(),&ww,_PROG_NAME);
} /* while */


   exit (-1);
}

/**
*   Loose Menu Item Action routines
**/

long ACT(wwk,li) struct WM_wwork *wwk; struct WM_litm *li;
{
   return li->skey+14;      /* calculate event for selection key */
}

static long AEXIT(wwk) struct WM_wwork *wwk;
{
   long evn;
   evn=0;
   switch(
   Radio_Select(DefaultColourSet(),0,"Exit","Ok to Quit",3,"Yes","No","Sleep"))
          { case 2: evn=PT__ZZZZ;
            case 1:
            case -1: lit_reset(wwk,lit_can);
                    return evn;
            case 0:
if (play) {
   FILE *fp;
   int m,n;
     fp = fopen("gnugo.dat", "w");
/* save board configuration */
     for (m = 0; m < 19; m++)
       for (n = 0; n < 19; n++)
           fprintf(fp, "%c", p[m][n]);
/* my color, pieces captured */
         fprintf(fp, "%d %d %d ", mymove, mk, uk);
/* opening pattern flags */
         for (m = 0; m < 9; m++)
           fprintf(fp, "%d ", opn[m]);

     fclose(fp);
     play = 0;
       }

           exit(0);
          }
}


static long AMOVE(wwk) struct WM_wwork *wwk;
{
   short dx,dy;
   wwk->wstat->evnt |= PT_WMOVE;   /* set event bit for wm_chwin */
   wm_chwin (wwk,&dx,&dy);         /* move window */
   wm_swdef (wwk, wwk->pappl->pappw, ((struct astat *) wwk->pappl->pappw->pstat)->chid);
   /* ADRAW (wwk,wwk->pappl->pappw); */  /* move keep the ap.. so no draw */
                                        /* just an ajust.. */
   return lit_reset (wwk,lit_move); /* and return */
}

static long AWAKE(wwk) struct WM_wwork *wwk;
{
   wm_swapp (wwk, 0, CL_WINK);     /* set to window */
   sd_clear (wwk->chid,-1);        /* clear */
   ADRAW (wwk,wwk->pappl->pappw);  /* draw */
   return lit_reset (wwk,lit_wake); /* and return */
}

struct WM_SPRITE *board(x,y)
char x,y;
{
if ((x==0)&&(y==0)) return &sp4_hautgauche;
if ((x==18)&&(y==0)) return &sp4_hautdroite;
if ((x==18)&&(y==18)) return &sp4_basdroite;
if ((x==0)&&(y==18)) return &sp4_basgauche;
if (x==0) return &sp4_gauche;
if (x==18) return &sp4_droite;
if (y==18) return &sp4_bas;
if (y==0) return &sp4_haut;

if ((x==3)&&(y==3)) return &sp4_noeud;
if ((x==9)&&(y==3)) return &sp4_noeud;
if ((x==15)&&(y==3)) return &sp4_noeud;
if ((x==3)&&(y==9)) return &sp4_noeud;
if ((x==9)&&(y==9)) return &sp4_noeud;
if ((x==15)&&(y==9)) return &sp4_noeud;
if ((x==3)&&(y==15)) return &sp4_noeud;
if ((x==9)&&(y==15)) return &sp4_noeud;
if ((x==15)&&(y==15)) return &sp4_noeud;
return &sp4_milieu;
}
static long ADRAW (wwk, apw) struct WM_wwork *wwk; struct WM_appw *apw;
{
struct astat *varia;
char i,j;
varia=apw->pstat;

for(i=0;i<=18;i++)
for(j=0;j<=18;j++)
{
iop_wspt(wwk->chid,-1,i*20,j*13,board(i,j));
if (p[i][j]==BLACK)
   iop_wspt(wwk->chid,-1,i*20,j*13,&sp4_rouge);
if (p[i][j]==WHITE)
   iop_wspt(wwk->chid,-1,i*20,j*13,&sp4_vert);
if (play==0)
{
if (t[i][j]==TWHITE)
   iop_wspt(wwk->chid,-1,i*20,j*13,&sp4_dvert);
if (t[i][j]==TBLACK)
   iop_wspt(wwk->chid,-1,i*20,j*13,&sp4_drouge);
if (t[i][j]==TNEUTRE)
   iop_wspt(wwk->chid,-1,i*20,j*13,&sp4_dnoir);
}
}
return 0;
}

static long AHIT(wwk,apw,wst) struct WM_wwork *wwk; struct WM_appw *apw;
                           struct WM_wstat *wst;
{
  int i,j, N,k;
  char tex[5];
if (play)
{
   if (wst->kprs==K_HIT)

   {
   wm_swdef (wwk, apw, wwk->chid);     /* set to window */
   i=abs(wst->xpos+10)/20;
   j=abs(wst->ypos+6)/13;
   if ((p[i][j] != EMPTY) || suicide(i, j))
       {
       return AHIT_NORMAL;
       }

     p[i][j] = umove;
     examboard(mymove);   /* remove my dead pieces */
     sprintf(tex,"%4.4d",mk);
     pass=0;
     QD_STXT(red_score,tex,4);
     sprintf(tex,"%4.4d",uk);
     QD_STXT(green_score,tex,4);
     ADRAW(wwk,apw);
     wm_idraw(wwk,0);
     if (pass != 2)
       {
        genmove(&i, &j);   /* computer move */
        if (i >= 0)   /* not pass */
          {
           p[i][j] = mymove;
           examboard(umove);   /* remove your dead pieces */
     sprintf(tex,"%4.4d",mk);
     QD_STXT(red_score,tex,4);
     sprintf(tex,"%4.4d",uk);
     QD_STXT(green_score,tex,4);
     sprintf(tex,"%c%d ",i+'a',j+1);
     QD_STXT(coup,tex,4);
   wm_swdef (wwk, apw, wwk->chid);     /* set to window */
     ADRAW(wwk,apw);
     wm_idraw(wwk,0);
         }
         else
{
     sprintf(tex,"Pass");
     QD_STXT(coup,tex,4);
   wm_swdef (wwk, apw, wwk->chid);     /* set to window */
     ADRAW(wwk,apw);
     wm_idraw(wwk,0);

}
      }
   }
}
else /* endgame */
{
int bcount=0,wcount=0;
if (wst->kprs==K_DO)
{
   wm_swdef (wwk, apw, wwk->chid);     /* set to window */
   i=abs(wst->xpos)/20;
   j=abs(wst->ypos)/13;
     if (p[i][j] == mymove)
       {
        N = bfslist(i, j, mymovelist, listpt);
        for (k=0;k<N;k++)
               {
                node2ij(listpt[k], &i, &j);
                p[i][j] = EMPTY;
               }
     }
    else
       if (p[i][j] == umove)
         {
              N = bfslist(i, j, umovelist, listpt);
              for (k=0;k<N;k++)
                 {
                  node2ij(listpt[k], &i, &j);
                  p[i][j] = EMPTY;
                 }
            }
}
if ((wst->kprs==K_HIT))
    {
   wm_swdef (wwk, apw, wwk->chid);     /* set to window */
   i=abs(wst->xpos)/20;
   j=abs(wst->ypos)/13;
     if (p[i][j] == EMPTY)
        {
        k=Radio_Select(DefaultColourSet(),0,"Add one","Drop a Stone for ?",3,"Black","White","Nobody");
        switch(k)
        {
            case 0: p[i][j]=BLACK;break;
            case 1: p[i][j]=WHITE;break;
        }
        }
     else
        {
        k=XDialog(DefaultColourSet(),"Minus one","Remove a stone",&sp_remove1,0);
        switch(k)
        {
            case 0: p[i][j]=EMPTY;break;
        }
        }
  /* recreate list, as chain may have changed */
  createlist(mymove, mymovelist);

  createlist(umove, umovelist);

    }
if ((wst->kprs==K_DO)||(wst->kprs==K_HIT))
{
for(i=0;i<19;i++)
for(j=0;j<19;j++)
 t[i][j]=p[i][j];
for(i=0;i<19;i++)
for(j=0;j<19;j++)
 if (t[i][j]==EMPTY)
    {
    k=findcolor(i,j);
    switch(k)
    {
    case EMPTY: t[i][j]=TNEUTRE;
        break;
    case BLACK: t[i][j]=TBLACK;bcount++;
        break;
    case WHITE: t[i][j]=TWHITE;wcount++;
        break;
        }
    }
for(i=18;i>=0;i--) /* redo, for propagation... */
for(j=18;j>=0;j--)
 if (t[i][j]==EMPTY)
    {
    k=findcolor(i,j);
    switch(k)
    {
    case EMPTY: t[i][j]=TNEUTRE;
        break;
    case BLACK: t[i][j]=TBLACK;bcount++;
        break;
    case WHITE: t[i][j]=TWHITE;wcount++;
        break;
        }
    }
     sprintf(tex,"%4.4d",mk+(mymove==1?bcount:wcount));
     QD_STXT(red_score,tex,4);
     sprintf(tex,"%4.4d",uk+(mymove==1?wcount:bcount));
     QD_STXT(green_score,tex,4);
   wm_swdef (wwk, apw, wwk->chid);     /* set to window */
     ADRAW(wwk,apw);
     wm_idraw(wwk,0);
}
}
   return AHIT_NORMAL;
}
static long APASS(wwk) struct WM_wwork *wwk;
{
  int i,j;
  char t[5];
   lit_reset(wwk,lit_play);
     pass++;
     if (pass != 2)
       {
        genmove(&i, &j);   /* computer move */
        if (i >= 0)   /* not pass */
          {
           p[i][j] = mymove;
           examboard(umove);   /* remove your dead pieces */
     sprintf(t,"%4.4d",mk);
     QD_STXT(red_score,t,4);
     sprintf(t,"%4.4d",uk);
     QD_STXT(green_score,t,4);
     sprintf(t,"%c%d ",i+'a',j+1);
     QD_STXT(coup,t,4);
     wm_swdef (wwk, wwk->pappl->pappw, wwk->chid);     /* set to window */
     ADRAW(wwk,wwk->pappl->pappw);
     wm_idraw(wwk,0);
         }
         else
{
     sprintf(t,"Pass");
     QD_STXT(coup,t,4);
     wm_swdef (wwk, wwk->pappl->pappw, wwk->chid);     /* set to window */
     ADRAW(wwk,wwk->pappl->pappw);
     wm_idraw(wwk,0);
}

      }
      if (pass > 1) play = 0;  /* both pass then stop game */
   return PT__HELP;
 }

static long ASLEEP(wwk) struct WM_wwork *wwk;
 { 
   lit_reset(wwk,lit_zzzz);        
   return PT__ZZZZ;
 }

static long AHELP(wwk) struct WM_wwork *wwk;
{
         lit_reset(wwk,lit_help);
         return PT__HELP;
}

static long ABOUT(wwk) struct WM_wwork *wwk;
 {
   Message_Report(DefaultColourSet(),"Free QL soft by\nJrme GRIMBERT\n\n-- No Charge --");
   return lit_reset (wwk,lit_about); /* and return */
}
